=== debian/changelog ===
mysql-shell (8.4.6+dfsg-0ubuntu1) questing; urgency=medium

  * New upstream version 8.4.6
  * d/copyright: Update file exclusions to fix empty directory issue

 -- Lena Voytek <lena.voytek@canonical.com>  Mon, 28 Jul 2025 13:21:41 -0400
