=== debian/control ===
Source: mysql-shell
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 4.6.2
Build-Depends: debhelper (>= 13~),
               bison,
               cmake (>= 2.8.5),
               dpkg-dev (>= 1.16.1~),
               git,
               libantlr4-runtime-dev (>=4.10), libantlr4-runtime-dev (<<4.11),
               libcurl4-openssl-dev,
               libedit-dev,
               libevent-dev,
               libicu-dev,
               libjson-perl,
               liblz4-dev,
               libncurses-dev,
               libprotoc-dev,
               libprotobuf-dev,
               libssh-dev (>=0.9.2),
               libssl-dev,
               libtinyxml2-dev,
               libtirpc-dev,
               libzstd-dev,
               lsb-release,
               lz4,
               mysql-source,
               openssl,
               perl,
               pkgconf,
               po-debconf,
               protobuf-compiler,
               psmisc,
               python3-dev (>= 3.8),
               unzip,
               zlib1g-dev (>= 1:1.1.3-5)
Homepage: http://dev.mysql.com/downloads/shell
Vcs-Git: https://github.com/mysql/mysql-shell.git
Vcs-Browser: https://github.com/mysql/mysql-shell

Package: mysql-shell
Architecture: amd64 arm64 s390x ppc64el riscv64
Depends: ${shlibs:Depends}, ${misc:Depends}, python3-certifi, python3-yaml
Description: MySQL Shell (part of MySQL Server) 8.4
 MySQL query and administration shell client and framework.
