=== debian/tests/control ===
Tests: managetables
Depends: mysql-shell, mysql-server
Restrictions: needs-root

Tests: secretstore
Depends: mysql-shell, mysql-server, jq
Restrictions: needs-root
