=== debian/watch ===
version=4
opts=\
downloadurlmangle=s/\/downloads\/gpg\/?\?file=(mysql-shell-([\d\.]*)-src.tar.gz).*/\/get\/Downloads\/MySQL-Shell\/$1/,pgpsigurlmangle=s/\/get\/Downloads\/MySQL-Shell\/(mysql-shell-([\d\.]*)-src.tar.gz)/\/downloads\/gpg\/?file=$1&p=43/,filenamemangle=s/\/downloads\/gpg\/?\?file=mysql\-shell\-([\d\.]*)\-src\.tar\.gz.*/mysql-shell-$1-src.tar.gz/,\
dversionmangle=auto,repacksuffix=+dfsg \
https://dev.mysql.com/downloads/shell/8.4.html?os=src /downloads/gpg/\?file=mysql-shell-([\d\.]*)-src.tar.gz&p=43
